# EchoLazyLoader

Gem for lazily loading the images using [Echo](https://github.com/toddmotto/echo) javascript library.

## Installation

Add this line to your application's Gemfile:

    gem 'echo_lazy_loader'

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem install echo_lazy_loader

## Usage

Add the following to your `app/assets/javascripts/application.js`:

    //= require echo

To use minified version use this:

    //= require echo.min

Use the following helper function instead of `image_tag` for images that you want to lazily load
	
	echo_image_tag src, options

This function takes same parameters as the `image_tag` helper.

You will also have to call the following function ( prefereably in application layout ).

	echo_init

If you want to apply lazy loading to images that donot show on scrolling but are swaped by some slider or filter layout , you can directly use this javascript code

	<script type="text/javascript">
		Echo.render();
	</script>
	
## Configuration

you can use `rails g echo_lazy_loader:config` that will generate `echo_lazy_loader.rb` in project's initializer folder.

The configurable options ( with default values) are as follows.

	default_image = "/assets/blankloading.gif"
	offset= 100
	throttle= 250

`default_image` is the path to the image which you want to show when the actual image is loading .
`offset` and `throttle` are used by the `Echo Library` and has been explained in its [documentation](https://github.com/toddmotto/echo#init-api-options) .

You can also pass the `offset` and `throttle` while calling `echo_init`. The values passed to the function will be used instead of those given in configuration file.


## Contributors

1. [Kinaan Khan Sherwani](https://github.com/kinaan-khan-confiz) ( kinaan.khan@confiz.com )
2. [Usman Ali](https://github.com/usman-ali-confiz) ( usman.ali@confiz.com)
3. [Ahmad Hussain](https://github.com/ahmad-hussain-confiz) ( ahmad.hussain@confiz.com)

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request
